
-- (c) IPM, University of Minho (2008/09 ; 2009/10)

import Ratio
import Ipm
import Abc

--- Abegg cell (cf. Robert Schumann's opus 1)

abeggCell = [ "A", "B", "e", "g", "g" ]
abeggRhythm = cycle [ 1 % 4, 1 % 4, 1 % 4, 1 % 4, 1 % 2 ]

abeggTheme = zip abeggCell abeggRhythm

abeggBars = [1%4]++(cycle [3%4])

test01 = abcPlay_ "F" "3/4" (divide abeggBars abeggTheme)

--- Retrogade Abegg cell

retrog m = let (l,r) = unzip m in zip (reverse l) r

test02 = abcPlay_ "F" "3/4" (divide abeggBars (retrog abeggTheme))

--- Complete Abegg theme

abegg_r = cycle (map (1%4*) [1,1,1,1,2])

abegg_t1 = ["A","B","e","g","g","^G","A","c","f","f","^F","G","B","d","d","E","F","A","c","c"]

abegg_t2 = ["g","g","e","B","A","a","a","f","d","c","c'","c'","a","f","d","d'","d'","b","g","f"]

abegg_tune = (zip (abegg_t1++abegg_t2) abegg_r)

--- Adding bars to Abegg theme

tune = divide abeggBars abegg_tune

test03 = abcPlay_ "F" "3/4" tune

--- First examples of Ipm supported music analysis:

-- (a) removing repeats (nrep):
-- nrep is generic, cf. eg. nrep [("a",1),("b",2),("b",3),("c",1)]

test04 = abcPlay_ "F" "3/4" (divide abeggBars (nrep abegg_tune))

-- (b) sampling (sample):

test05 = abcPlay_ "F" "3/4" stune
         where stune = divide bars (sample abeggSample abegg_tune)
               bars = [1%4] ++ cycle [3%4]
               abeggSample = bars

test06 = abcPlay_ "F" "6/4" stune
         where stune = divide bars (sample abeggSample abegg_tune)
               bars = [1%4] ++ cycle [6%4]
               abeggSample = [1%4] ++ ntimes [6%4] 3 ++ [9%4] ++ cycle [6%4]

--- Joke: my name with Abegg's rhythm 

test07 w = abcPlay_ "F" "3/4" (divide abeggBars (zip (name2music w) abegg_r))

