
-- (c) IPM, University of Minho (2008/09 ; 2009/10)

import Ratio
import Ipm
import Abc
import Cp

royalTheme :: [(String, Ratio Int)]
royalTheme = [("C",1%2),("E",1%2),("G",1%2),("A",1%2),("=B,",1%2),("z",1%4),("G",1%2),("^F",1%2),("=F",1%2),("=E",1%2),("_E",1%2),("=D",1%4),("_D",1%4),("C",1%4),("=B,",1%4),("G,",1%4),("C",1%4),("F",1%4),("E",1%2),("=D",1%2),("C",1%2),("E",1%2)]

unitb = ["G","F","G","c","G","E","D","E","F","G","=A","=B","c","E","F","G","_A","D","E","F","G","F","E","D","E","F","G","A","B","A","G","F","G","A","B","c","_d","_B","_A","G","=A","=B","c","d","e","c","=B","=A","=B","c","d","e","f","d","G","d","c","d","e","f","e","d","c","=B","c","G","E","C"]

counterTheme = zip unitb (ntimes (ntimes [1%8] 8 ) 8 ++ (ntimes [1%4] 4))

royalTheme_m = map fst royalTheme -- extracts melodic line from royal theme

royalTheme_r = map snd royalTheme -- extracts rythmic line from royal theme

royalThemeBars = repeat (4%4)     -- bar is 4/4

wholeTheme = royalTheme++counterTheme

-- List of exercises:

test01 = abcPlay "Cm" "C" royalTheme

test02 = abcPlay "Cm" "C" counterTheme

test03 = abcPlay "Cm" "C" (map (id >< (/2)) royalTheme)  -- twice as fast

test04 = abcPlay "Cm" "C" wholeTheme

test05 = abcPlay "Cm" "C" (reverse wholeTheme)

test06 = abcPlay_ "Cm" "C" (divide bars twoparts)
                   where twoparts = wholeTheme :|: (reverse wholeTheme)
                         bars =  repeat (4%4)

test07 = abcPlay "Cm" "C" (sample (repeat (1%1)) royalTheme)

twoparts = wholeTheme :|: (reverse wholeTheme)

